/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package service.impl;

import database.broker.DatabaseBroker;
import domain.Product;
import java.util.List;
import service.ServiceProduct;
import storage.StorageProduct;
import storage.impl.database.StorageDatabaseProduct;

/**
 *
 * @author student1
 */
public class ServiceProductImpl implements ServiceProduct {

    private final StorageProduct storageProduct;
    private final DatabaseBroker databaseBroker;

    public ServiceProductImpl() {
        storageProduct = new StorageDatabaseProduct();
        databaseBroker = new DatabaseBroker();
    }

    @Override
    public Product save(Product product) throws Exception {
        try {
            return (Product) databaseBroker.save(product);
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            throw new Exception("Product is not saved");
        }

    }

    @Override
    public List<Product> getAll() throws Exception {
        return storageProduct.findAll();
    }

}
